#include <stdlib.h>
#include <sys/fcntl.h>
#include <sys/stat.h>
#include <errno.h>
#include <string.h>
#include <stdio.h>

int *frames;
int nframes;

static void count_frames(unsigned char *file, int len)
{
  int N= 0,i;
  for(i=0;i<len-1;i++) 
    if (file[i]==0xff && (file[i+1]&0xe0)==0xe0)  N++;
  frames= malloc(sizeof(int)*(N+1));
  N= 0;
  for(i=0;i<len-1;i++)
    if (file[i]==0xff && (file[i+1]&0xe0)==0xe0) frames[N++]= i;
  nframes= N;
}


int main(int argc,char **argv)
{
  int i,start,end;
  if (argc<2) exit(fprintf(stderr,
               "usage: %s filename [start] [end]\n", argv[0]));
  char *fn= argv[1];
  int fd= open(fn, O_RDONLY);
  struct stat sbuf;
  if (fd<0)
    exit(fprintf(stderr,"can't open %s: %s\n", fn, strerror(errno)));
  if (fstat(fd, &sbuf))
    exit(fprintf(stderr,"can't stat %s: %s\n", fn, strerror(errno)));
  unsigned char *file;
  int file_len;
  file_len= sbuf.st_size;
  file= malloc(file_len);
  if (read(fd, file, file_len)!=file_len)
    exit(fprintf(stderr,"can't read file in full\n"));
  count_frames(file, file_len);
  fprintf(stderr,"#frames= %d\n", nframes);
  if (argc==2) return 0;
  start= atoi(argv[2]);
  if (argc>3) end= atoi(argv[3]); else end= nframes-1;
  if (start<0) start= 0; if (end>=nframes) end= nframes-1;
  start= frames[start];
  if (end<nframes-1) end= frames[end+1];
  else end= file_len;
  write(1, file+start, end-start);
  return 0;
}

